var http = require("http");
var url  = require("url");
var exec = require("child_process").exec;

var BUFSIZE = 101;
var data = new Array(BUFSIZE);
var datp = 0;


function start(route, handle) {

function init_data() {
    var i;
	var d;
	for (i=0; i<BUFSIZE; i++) {
		d = Math.sin(Math.PI/50.0*i);
		data[i] = ~~(d*100+128);
	}
}

function i2c_get() {
//	var cmd = "./i2cdummy "+datp.toString(16);
	var cmd = 'i2cget -y 1 0x08 0x00';
	console.log(cmd);

	exec(
		cmd,
		function(err, stdout, stderr) {
			data[datp] = parseInt(stdout,16);
			console.log('=>'+data[datp]);
			datp++;
			if (datp >= BUFSIZE) {
				datp = 0;
			}
		}
	);
}

function draw_graph() {
	var i;
	var valbuf = '\tdata[0] = ' +data[0].toString(10) + ';\n';

	for (i=1; i<BUFSIZE; i++) {
	  valbuf = valbuf+ '\t'+
	    'data['+ i + '] = ' + data[i].toString(10) + ';\n';
	}
	console.log(valbuf);

	var drawbuf = '<!DOCTYPE html>' + '\n'+
	'<html>' + '\n'+
	'<head>' + '\n'+
	'<meta charset="utf-8">' + '\n'+
	'<title>Canvas TEST</title>' + '\n'+
	'<style type = "text/css">' + '\n'+
	'canvas {border: 1px solid black; }' + '\n'+
	'</style>' + '\n'+
	'<script type = "text/javascript">' + '\n'+
	'const CHEIGHT = 300;' + '\n' +
	'const CWIDTH  = 400;' + '\n' +
	'const BUFSIZE = 101;' + '\n' +
	'var data = Array(BUFSIZE); ' + '\n' +
	'var datp = ' + datp + ';' + '\n' +
	valbuf + 
	'function draw(context) {' + '\n'+
	'	var i;' + '\n' + 
	'	context.fillStyle=\'rgb(255,0,0)\';' + '\n'+
	'	context.strokeStyle = "black";' + '\n'+
	'	context.lineWidth = 1;' + '\n'+
	'	context.lineCap = \'round\';' + '\n'+
	'	context.beginPath();' + '\n'+
	'	context.moveTo(0, CHEIGHT/2);' + '\n' + 
	'	context.lineTo(CWIDTH, CHEIGHT/2);' + '\n' + 
	'	for (i=0; i<BUFSIZE; i+=10) {' + '\n'+
	'		context.moveTo(i*4, (CHEIGHT/2)-10);'+'\n'+
	'		context.lineTo(i*4, (CHEIGHT/2)+10);'+'\n'+
	'	}' + '\n' +
	'	context.moveTo(0, 128- data[datp++] + CHEIGHT/2);' + '\n' +
	'	for (i=1; i<BUFSIZE; i++) {' + '\n' +
	'	  if (datp >= BUFSIZE) datp = 0;' + '\n' +
	'	  context.lineTo(i*4, 128 - data[datp++] + CHEIGHT/2);'+'\n' + 
	'	}' + '\n' +
	'	context.stroke();' + '\n'+
	'}' + '\n'+
	'window.onload = function() {' + '\n'+
	'	var canvas = document.getElementById(\'mycanvas\');' + '\n'+
	'	if (!canvas.getContext) {' + '\n'+
	'		return;' + '\n'+
	'	}' + '\n'+
	'	var context = canvas.getContext(\'2d\');' + '\n'+
	'	draw(context);' + '\n'+
	'}' + '\n'+
	'</script>' + '\n'+
//	'<meta http-equiv="refresh" content="5">'+
	'</head>' + '\n'+
	'<body>' + '\n'+
	'        <canvas id = "mycanvas" width="400" height="300">' + '\n'+
	'		Canvas not supported.' + '\n'+
	'        </canvas>' + '\n'+
	'	<form action="/" method="post">' + '\n' +
	'	<input type="submit" value="Submit Test">' + '\n' +
	'	</form>' + '\n' +
	'</body>' + '\n'+
	'</html>'+'\n';
    return(drawbuf);
}

function onRequest(req, res) {
		var pathname = url.parse(req.url).pathname;

		var drawbuf = draw_graph();
		console.log("Request for "+ pathname + " received.");
		res.writeHead(200, { "Content-Type":"text/html"});
		res.write(drawbuf);
		res.end();
}

function getdata() {
	setInterval(function() {
		i2c_get();
	}, 1000);
}

init_data();
http.createServer( onRequest ).listen(8000);
console.log("Waiting for Port 8000");
getdata();

}	// end of 'start('

start();
